<script>
import { REFER } from "./api/index";
import deepCopy from "@gby/deep-copy";
export default {
  name: "PopoverTreeSelect",
  props: {
    // 参照类型 ，对应后端
    type: {
      type: String,
      require: true,
    },
    // v-model
    value: {
      type: [Array, String],
      require: true,
    },
    // 参照弹窗标题
    title: {
      type: String,
      default: "TITLE",
    },
    // 作为 value 唯一标识的键名，绑定值
    valueKey: {
      type: String,
      default: "code",
    },
    // 默认查询参数
    queryParams: {
      type: Function,
      default: () => {},
    },
    // 组件大小
    size: {
      type: String,
      default: "mini",
    },
    // 提示
    placeholder: {
      type: String,
      default: "",
    },
    // 是否可读
    readonly: {
      type: Boolean,
      default: false,
    },
    // 是否禁止
    disabled: {
      type: Boolean,
      default: false,
    },
    // 是否清除
    clearable: {
      type: Boolean,
      default: false,
    },
    // 是否多选
    multiple: {
      type: Boolean,
      default: false,
    },
    // 需映射源数据
    source: Object,
    // 参照内外映射
    dataMapping: Object,
  },
  components: {},
  data() {
    return {
      width: "50%",
      visible: false,
      loading: false,
      params: {
        search: "",
        isPage: true,
      },
      data: [],
      selectData: [],
      lastSelectData: [],
      defaultProps: {
        label: "name",
        children: "children",
      },
    };
  },
  computed: {
    innerValue() {
      const { value, multiple } = this.$props;
      return multiple ? "" : value;
    },
    TableColumnTemp() {
      const { type } = this.$props;
      const documents = require(`./components/${type}`).default;
      return documents.filter((document) => document.key);
    },
  },
  watch: {
    "$props.value": {
      handler: function (newProp) {
        console.log("newProp", newProp);
        if (!newProp) this.lastSelectData = [];
      },
      immediate: true,
    },
  },
  methods: {
    //
    emitChange(prop) {
      const { type, source, multiple } = this.$props;
      this.$emit("change", multiple ? prop : prop[0], source, type);
    },
    // open dialog
    async open() {
      this.visible = true;
      await this.useReset();
    },
    // hide dialog
    async hide() {
      this.visible = false;
    },
    // fetch list
    async fetchList(prop) {
      try {
        this.loading = true;
        const { code, rows } = await REFER(prop);
        if (code === 200) {
          this.data = rows;
        }
      } catch (err) {
        // catch
        console.error(err);
      } finally {
        // finally
        this.loading = false;
      }
    },
    // reset list
    async useReset() {
      const { type, source, queryParams } = this.$props;
      this.model = {
        type,
        search: "",
        ...this.model,
        ...queryParams(source),
      };
      await this.fetchList(this.model);
    },
    // query list
    async useQuery() {
      await this.fetchList(this.model);
    },
    // cancel
    useCancel(prop) {
      const { multiple } = this.$props;
      this.useUpdate(multiple ? prop : prop[0]);
      this.hide();
    },
    // confirm
    useConfirm(prop) {
      const { multiple } = this.$props;
      this.useUpdate(multiple ? prop : prop[0]);
      this.emitChange(this.selectData);
      this.lastSelectData = deepCopy(this.selectData);
      this.hide();
    },
    // delete tag
    useDelete(prop) {
      this.selectData.splice(prop, 1);
      this.useUpdate(this.selectData);
      this.emitChange(this.selectData);
      this.lastSelectData = deepCopy(this.selectData);
    },
    // update
    useUpdate(prop) {
      const { source, multiple, valueKey, dataMapping, type } = this.$props;
      // update data mapping
      if (multiple) {
        const vModel = prop.map((item) => item[valueKey]);
        this.$emit("input", vModel);
      } else {
        const vModel = prop[valueKey];
        this.$emit("input", vModel);
        for (let key in dataMapping) {
          source[key] = prop[dataMapping[key]];
        }
        this.$emit("update:source", source);
      }
    },
    // click select row data
    onceSelect(prop) {
      if (prop) this.selectData = [prop];
    },
    // double click select row data and confirm
    doubleSelect(prop) {
      this.useConfirm([prop]);
    },
    // multiple select row data
    selectionChange(prop, data) {
      if (prop) {
        this.selectData.push(data);
      } else {
        const { code } = data;
        const index = this.selectData.findIndex((item) => item.code === code);
        this.selectData.splice(index, 1);
      }
    },
  },
  created() {},
  mounted() {},
  destroyed() {},
};
</script>
<template>
  <div class="popover-tree-select">
    <el-input
      v-model="innerValue"
      :size="size"
      :disabled="disabled"
      :readonly="readonly"
      :clearable="clearable"
      :placeholder="placeholder"
    >
      <el-button
        :disabled="disabled"
        slot="append"
        icon="el-icon-search"
        @click="open"
      ></el-button>
    </el-input>

    <el-dialog
      :title="`${title}（${multiple ? '多选' : '单选'}）`"
      :width="width"
      :visible.sync="visible"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      append-to-body
      @close="hide"
    >
      <el-form
        v-loading="loading"
        :size="size"
        :inline="true"
        :model="params"
        @submit.native.prevent
      >
        <el-form-item prop="search">
          <el-input
            v-model="params.search"
            @keydown.enter="useQuery"
            @change="useQuery"
          >
          </el-input>
        </el-form-item>
        <el-form-item>
          <el-button icon="el-icon-refresh" @click="useReset"></el-button>
        </el-form-item>
      </el-form>
      <el-tree
        v-if="multiple"
        :data="data"
        :props="defaultProps"
        accordion
        node-key="id"
      >
        <div slot-scope="{ node, data }">
          <el-checkbox
            v-model="data.checked"
            @click.native.stop
            @change="selectionChange($event, data)"
            style="margin: 0 5px 0 0"
          >
          </el-checkbox>
          <span> {{ data.name }}</span>
        </div>
      </el-tree>
      <el-radio-group v-else v-model="radio" style="width: 100%">
        <el-tree
          v-loading="loading"
          :data="data"
          :props="defaultProps"
          accordion
          node-key="id"
        >
          <div slot-scope="{ node, data }">
            <el-radio
              :label="data.code"
              @click.native.stop="onceSelect(data)"
              @dblclick.native.stop="doubleSelect(data)"
              style="margin: 0 5px 0 0"
            >
              {{ data.name }}
            </el-radio>
          </div>
        </el-tree>
      </el-radio-group>
      <div style="margin-top: 20px; text-align: right">
        <el-button :size="size" @click="visible = false">取 消</el-button>
        <el-button :size="size" type="primary" @click="useConfirm(selectData)"
          >确 定</el-button
        >
      </div>
    </el-dialog>
    <div
      style="
        position: absolute;
        left: 10px;
        top: 50%;
        transform: translateY(-50%);
        padding-right: 30px;
        overflow: hidden;
      "
    >
      <div v-if="multiple && lastSelectData.length">
        <el-popover
          :offset="-10"
          :width="width"
          :visible-arrow="false"
          title=""
          content=""
          trigger="click"
          placement="bottom-start"
        >
          <el-tag slot="reference" :size="size" style="margin-right: 10px">
            + {{ lastSelectData.length }}
          </el-tag>
          <el-tag
            v-for="(tag, index) in lastSelectData"
            :size="size"
            hit
            closable
            :style="{
              display: 'flex',
              justifyContent: 'space-between',
              alignItems: 'center',
              margin: lastSelectData.length - 1 === index ? '0' : '0 0 5px 0',
            }"
            @close="useDelete(index)"
          >
            {{ tag.name }}
          </el-tag>
        </el-popover>
      </div>
    </div>
  </div>
</template>
<style scoped></style>
